/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _SENDMAIL_
#define _SENDMAIL_

#include <sys/param.h>
#include <errno.h>
#include <string.h>
#include "wrapper.h"
#include "base64.h"
#include "util.h"
#include "socket.h"

typedef enum {
  NOTHING,
  EHLO,
  MAIL_FROM,
  RCPT_TO,
  AUTH_PLAIN,
  AUTH_LOGIN,
  DATA,
  QUIT
} SMTP_STATE ;

typedef enum {
  NONE,
  PLAIN,
  LOGIN
} SMTP_AUTH ;

void set_sendmail_timeout(int);
void set_max_timeout_number(int);
int get_helo(char **);
int get_authplain(char **, const char *, const char *);
int get_mailfrom(char **, const char *);
int get_rcptto(char **, const char *);
char *SMTP_STATE_STRING(SMTP_STATE);
int sendmail(const char *, const char *,
             const char *, const char *,
             const char *, const char *, SMTP_AUTH, 
             const char *, const char *);

#endif
