/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _OPENDD_
#define _OPENDD_

#include "./include/chain_string.h"
#include "./include/socket.h"

#define RETURN_CODE_GOOD "good"
#define RETURN_CODE_NOCHG "nochg"

#define EXIT_DYNDNS_SUCCESS 1
#define EXIT_DYNDNS_FAILED 500

#ifdef __Linux__
void linux_setproctitle(char *, ...);
#define SETPROCTITLE	linux_setproctitle
#elif defined __FreeBSD__ || defined __OpenBSD__ || defined __NetBSD__
#define SETPROCTITLE	setproctitle
#endif

int check_config_file_mode(const char *);
char *get_pidfile_path(void);
int open_lock_pidfile(void);
int write_pid_lock_pidfile(void);
int close_lock_pidfile(void);
int empty_lock_pidfile(void);
int get_second_lifetime(void);
void set_second_lifetime(int);
int get_force_update_status(void);
void set_force_update_status(int);
void update_proc_title(void);
int send_report(const char *, const char *);
int getdyndnshostnames(const char *, struct chain_string **, int);
int getifaceaddr(char **);
int runasdaemon(void);
int drop_privileges(void);
int getpollfrequency(void);
int get_domain_lifetime(void);
int use_syslog(void);
int syslog_facility(void);
int dyndns(const char *, struct chain_string *);
int listen_response(Socket *);

#endif

